/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  .BBS-file display routines                                             *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <stdarg.h>
#include <io.h>
#include <fcntl.h>
#include "prog.h"
#include "max.h"
#include "max_msg.h"

/* Some NEAR functions to increase speed... */

static int near pascal Parse_MagnusCode(char *filename,FILE *bbsfile,int ck_abort,char **filebufr,FILE *questfile,int type);
static int near pascal Parse_Questionnaire(FILE *bbsfile,FILE **questfile,char *onexit,char *filename,int *ck_abort,int *recd_chars,int *skipcr,char **filebufr,char *nonstop,int allanswers);
static void near pascal Parse_Datacode(FILE *bbsfile,int *ck_abort,int *allanswers,int type);
static void near pascal Fix_RLE(char *s);
static char * pascal Get_BBS_String(char *string,FILE *bbsfile,int max);
static void pascal Add_Full_Path(char *src,char *dest);
static void near pascal PF(FILE *bbsfile,int n);

/* These are static variables so they can be carried across Display_File() *
 * calls.                                                                  */

static int l_ck_abort,
           l_automore;

static char l_nonstop;


/* This routine must, *MUST* be re-entrant.  Chances are that a            *
 * Display_File() command will get executed inside one of the files        *
 * you're displaying, and chances are even greater if the Sysop uses a     *
 * `[link]' command!                                                       */

#ifdef __MSC__
#pragma check_stack(on)
#endif

int cdecl Display_File(int type,char *o_nonstop,char *fname,...)
{
  REGISTER FILE *bbsfile;
  REGISTER int ch;            /* Holds the character we're processing */

  FILE *questfile;

  char onexit[PATHLEN],       /* What we display at the end of this file */
       filename[PATHLEN],     /* Filename to display */
       *nonstop,
       chcount,
       chcount_n,
       a_nonstop,
       *p;

  int skipcr,
      recd_chars,
      automore,
      ck_abort,
      doing_filesbbs,
      newfiles,
      searchfiles,
      search_areaname,
      doing_hotmenu,
      allanswers,
      ret,                    /* Return code for Display_File */
      x;

  va_list var_args;

  char string[PATHLEN],       /* Temporary holding place for filename */
       temp[255],             /* Another scratch string */
       *filebufr,             /* A buffer for reading operations in Display_File. */
       break_loop;

  if (++nested > MAX_NEST)
  {
    logit(s(log_max_nest),fname);
    nested--;
    return -1;
  }

  doing_filesbbs=(type & DISPLAY_filesbbs);
  newfiles=(type & DISPLAY_newfiles);
  searchfiles=(type & DISPLAY_search);
  doing_hotmenu=(type & DISPLAY_hotmenu);
  search_areaname=(type & DISPLAY_areaname);

  if (o_nonstop)
    nonstop=o_nonstop;
  else nonstop=&a_nonstop;

  if (searchfiles)
    current_col=1;

  if (nested <= 1 || doing_filesbbs)  /* Options should carry through across linked files! */
  {
    if (! search_areaname)  /* If we're doing a L)ocate command */
      display_line=display_col=1;

    lastmenu=0;

    ck_abort=automore=TRUE;

    /* So that the nonstop-more command will carry across file areas */

    if ((!searchfiles && !newfiles) || first_search)
      *nonstop=last_nonstop=FALSE;
    else *nonstop=last_nonstop;

    nested=1;
  }
  else
  {
    ck_abort=l_ck_abort;
    automore=l_automore;
    *nonstop=l_nonstop;
  }

  *onexit='\0';

  allanswers=recd_chars=FALSE;
  chcount=chcount_n=0;
  questfile=NULL;

  va_start(var_args,fname);
  vsprintf(filename,fname,var_args);
  va_end(var_args);

New_File:

  skipcr=FALSE;
  ret=0;


  Convert_Star_To_Task(filename);

  if (strchr(filename,'+'))
  {
    while ((p=strchr(filename,'+')) != NULL)
      *p='%';

    Parse_Outside_Cmd(filename,temp);
    strcpy(filename,temp);
  }

  /* Add full path to 'filename', and put result in 'string'. */
  Add_Full_Path(filename,string);

  /* Now copy it back to 'filename', so we can use it later. */
  strcpy(filename,string);

  strcat(string,dotgbs);

  if (graph==GRAPHICS_none || (bbsfile=shfopen(string,fopen_readb,O_RDONLY | O_BINARY))==NULL)
  {

BBSfile:
    strcpy(string,filename);
    strcat(string,dotbbs);

    if ((bbsfile=shfopen(string,fopen_readb,O_RDONLY | O_BINARY))==NULL)
    {
      if ((bbsfile=shfopen(filename,fopen_readb,O_RDONLY | O_BINARY))==NULL)
      {
        nested--;
        return -1;
      }
    }
  }
  else
  {
    FFIND *test;

    /* Don't allow display of FILES.GBS files with hidden/readonly attribs! */

    if ((test=FindOpen(string,MSDOS_hidden | MSDOS_system | MSDOS_readonly)) != NULL)
    {
      if (test->ff_attrib & (MSDOS_hidden | MSDOS_system))
      {
        FindClose(test);

        if (bbsfile)
          fclose(bbsfile);

        goto BBSfile;
      }

      FindClose(test);
    }

  }

  /* If we can scrounge up enough memory to fully-buffer this file... */
  if ((filebufr=malloc(FILEBUFSIZ)) != NULL)
    setvbuf(bbsfile,filebufr,_IOFBF,FILEBUFSIZ);
  /* otherwise don't worry about it, we'll just have to run a bit slower */

  if (rst_offset != -1L)
  {
    fseek(bbsfile,rst_offset,SEEK_SET);
    strcpy(onexit,last_onexit);
    rst_offset=-1L;
  }

  *last_onexit='\0';

  break_loop=FALSE;

  while (1)
  {
    /* Hotkeys, when displaying a menu */

    if (doing_hotmenu && ++chcount >= 4)
    {
      chcount=0;

      if (hotkeys(usr) && ck_abort && Mdm_keyp())
      {
        if (Mdm_kpeek()=='\x08' || Mdm_kpeek()=='\x09')
          Mdm_getcw();
        else if (Mdm_kpeek()=='\x00') /* Throw out scan code too */
        {
          Mdm_getcw();
          Mdm_getcw();
        }
        else
        {
          /* Clear the output */
          mdm_dump(DUMP_output);
          break_loop=TRUE;
          ret=4;
          break;
        }
      }
    }

    if (! doing_filesbbs)
    {
      ch=getc(bbsfile);

Process_Char:

      if (ch != EOF)
      {
        switch(ch)
        {
          case 1:
            *nonstop=FALSE;
            Press_ENTER();
            skipcr=TRUE;
            break;

          case 2:
            ck_abort=FALSE;
            break;

          case 3:
            ck_abort=TRUE;
            break;

          case 4:
            switch (MoreYnns())
            {
              case YES:
                break;

              case M_NONSTOP:
                *nonstop=TRUE;
                break;

              case NO:
                break_loop=TRUE;
                ret=-2;
                break;
            }

            display_line=1;
            break;

          case 5:
            automore=TRUE;
            break;

          case 6:   /* Control-F */
            Parse_Datacode(bbsfile,&ck_abort,&allanswers,type);
            break;

          case 7:   /* A bell (beep) */
            recd_chars=TRUE;
            Putc('\x07');
            break;

          case 11:
            automore=FALSE;
            break;

          case 15:  /* Control-O */
            l_ck_abort=ck_abort;
            l_automore=automore;
            l_nonstop=*nonstop;

            switch (Parse_Questionnaire(bbsfile,&questfile,onexit,filename,
                    &ck_abort,&recd_chars,&skipcr,&filebufr,nonstop,
                    allanswers))
            {
              case 1:
                goto End_Display;

              case 2:
                goto New_File;
            }
            break;

          case 16:  /* Control-P */
            switch (Parse_Priv(bbsfile))
            {
              default:
              case SKIP_none:
                break;

              case SKIP_file:
                goto End_Display;

              case SKIP_line:
                Skip_Line(bbsfile);

                beginline=TRUE;
                break;
            }
            break;

          case 22:
            Putc(ch);                  /* ^V */

            Putc(ch=fgetc(bbsfile));

            switch (ch)
            {
              case '\x01':                  /* ^A */
                if ((ch=fgetc(bbsfile))==DLE)
                {
                  Putc(DLE);           /* ^P */
                  ch=fgetc(bbsfile);
                }

                Putc(ch);
                break;

              case '\x08':
                PF(bbsfile,2);
                break;

              case '\x0a':            /* Five trailing chars total */
              case '\x0b':
                PF(bbsfile,5);
                break;

              case '\x0d':            /* Four trailing chars total */
                PF(bbsfile,4);
                break;

              case '\x0c':            /* Three trailing chars total */
                PF(bbsfile,3);
                break;

              case '\x19':            /* Repeat pattern */
                Putc(ch=fgetc(bbsfile));

                for (x=0;x <= ch;x++) /* Output ch+1 chars */
                  PF(bbsfile,1);
                break;
            }
            break;

          case 23:

            /* Set these here, in case we're doing a link */

            l_ck_abort=ck_abort;
            l_automore=automore;
            l_nonstop=*nonstop;

            switch (Parse_MagnusCode(filename,bbsfile,ck_abort,&filebufr,
                                     questfile,type))
            {
              case -4:
                ret=-4;
                *onexit='\0';
                *last_onexit='\0';
                goto End_Display;

              case SKIP_line:
                Skip_Line(bbsfile);
                beginline=TRUE;
                break;
            }
            break;

          case 25:                       /* RLE stuff */
            if (ck_abort && (brk_trapped || mdm_halt()))
            {
              brk_trapped=0;
              mdm_dump(DUMP_all);
              ret=-3;
              goto End_Display;
            }

            Putc('\x19');

            PF(bbsfile,2);
            break;

          case 26:
            goto End_Display;

          case 13:      /* Don't send \r's...  \n translates into \r\n! */
            if (!skipcr)
              recd_chars=TRUE;
            break;

          case 10:
            beginline=TRUE;

            if (skipcr)
            {
              skipcr=FALSE;
              break;
            }
            /* fall-through */

          default:
            if (++chcount_n >= 3)
            {
              if (ck_abort && (brk_trapped || mdm_halt()))
              {
                brk_trapped=0;
                mdm_dump(DUMP_all);
                ret=-3;
                goto End_Display;
              }

              chcount_n=0;
            }

            /* fall-through */

          case 12:
            recd_chars=TRUE;

            Putc(ch);
            break;
        }
      }
      else break;
    }
    else if (current_col==1 && !wrap) /* FILES.BBS display */
    {
      if ((ch=getc(bbsfile)) != EOF)  /* See if we're at EOF */
      {
        if (ch=='@' && beginline)
        {
          if (!GEPriv(usr.priv,ASSTSYSOP))
            goto End_Display;
        }
        else if (ch=='\r')
          beginline=TRUE;
        else if (ch=='-')
        {
          if (!newfiles && !searchfiles)
            Puts(WHITE "-");

          beginline=FALSE;
        }
        else if (ch <= 32)
        {
          if (ch==10 || ch==16)
            beginline=TRUE;
          else beginline=FALSE;

          if ((!newfiles && !searchfiles))
          {
            if (ch==22)
              wrap=TRUE;

            goto Process_Char;
          }
          else if (ch==16)
            goto Process_Char;
        }
        else
        {
          static int cnt;
          
          if (ck_abort && (brk_trapped || mdm_halt()))
          {
            brk_trapped=0;
            mdm_dump(DUMP_all);
            ret=-3;
            goto End_Display;
          }

          if (cnt++ >= 40)  /* Check status every 40 entries */
          {
            Mdm_check();
            cnt=0;
          }

          *temp=(char)ch;

          if (fgets(temp+1,sizeof(temp)-1,bbsfile))
          {
            if (beginline &&
                Process_Files_Entry(&type,temp,nonstop,ck_abort)==-2)
            {
              ret=-2;
              goto End_Display;
            }
            else beginline=TRUE;
          }
          else break;
        }
      }
      else break;
    }
    else if (!newfiles && !searchfiles)
    {
      if ((ch=fgetc(bbsfile))==EOF)
        break;

      goto Process_Char;
    }

    if (automore && !break_loop && display_col==1 &&
        MoreYnBreak(nonstop,NULL))
    {
      ret=-2;
      break;
    }

    if (break_loop)
      break;
  }

End_Display:

  fclose(bbsfile);

  last_nonstop=*nonstop;

  if (filebufr)
  {
    free(filebufr);
    filebufr=NULL;
  }

  if (questfile)
  {
    fputc('\n',questfile);
    fclose(questfile);
  }

  if (*onexit)
  {
    strcpy(filename,onexit);
    *onexit='\0';
    *last_onexit='\0';
    goto New_File;
  }

  /* If we're on our way OUT of the .BBS file, then restore to the         *
   * directory we started displaying from.  We use the ALTERNATE save-     *
   * directory routines, so that we end up in the same directory the       *
   * function was called in, regardless of whether or not the calling      *
   * function used the primary Save_Directory() routine.                   */

  if (--nested==0)
    Restore_Directories2();

  return ret;
}


static void near pascal Parse_Datacode(FILE *bbsfile,int *ck_abort,int *allanswers,int type)
{
  FILE *quotefile;
  char string[PATHLEN];

  time_t longtime;
  struct tm *localt;

  int first,
      x;

  switch(fgetc(bbsfile))
  {
    case 1:   /* Quote */
      sprintf(string,"%s.BBS",PRM(quote));

      if ((quotefile=shfopen(string,fopen_read,O_RDONLY)) != NULL)
      {
        fseek(quotefile,bstats.quote_pos,SEEK_SET);
        first=TRUE;

        while (1)
        {
          fgets(string,PATHLEN,quotefile);
          Trim_Line(string);

          /* If end of quote, get out of loop */

          if (! *string || *string=='\n' || feof(quotefile))
            break;

          if (!first)
            Putc('\n');
          else first=FALSE;

          Puts(string);
        }

        /* Wrap around... */

        if (feof(quotefile))
          bstats.quote_pos=0L;
        else bstats.quote_pos=ftell(quotefile);

        fclose(quotefile);
      }
      break;

    case 2:   /* User's name */
      Puts(usr.name);
      break;

    case 3:   /* User's city/state */
      Puts(usr.city);
      break;

    case 4:   /* Current date (string) */
      longtime=time(NULL);
      localt=localtime(&longtime);

      strftime(string,15,"%d %b %y",localt);
      Puts(string);
      break;

    case 5:   /* Total number of usercalls (ordinal) */
      x=usr.times+((type & DISPLAY_pcall) ? 1 : 0);

      Printf("%d%s",x,Ordinal(x));
      break;

    case 6:   /* User's first name */
      Puts(firstname);
      break;

    case 7:   /* Dramatic pause */
      if (*ck_abort)
        Mdm_flush_ck();
      else Mdm_flush();

      vbuf_flush();

      longtime=timerset(50);

      while (! timeup(longtime))
      {
        Mdm_check();
        Giveaway_Slice();
      }

      break;

    case 11: /* Total minutes on-line in past 24hrs, including current call */
      Printf(pd,usr.time+timeonline());
      break;

    case 12:  /* Length of current call, in minutes */
      Printf(pd,timeonline());
      break;

    case 14:  /* Disconnect user */
      if (*ck_abort)
        Mdm_flush_ck();
      else Mdm_flush();

      mdm_hangup();
      break;

    case 15:  /* Num of minutes remaining for call */
      Printf(pd,timeleft());
      break;

    case 16:  /* Date/time user must be off system (with C/R!) */
      strftime(string,26,asctime_format,localtime((time_t *)(&timeoff)));
      Puts(string);
      break;

    case 17:  /* Total number of system calls (ordinal) */
      Printf("%lu%s",bstats.num_callers,
             Ordinal((unsigned int)bstats.num_callers));
      break;

    case 18:  /* Net downloads (dl-ul) */
      Printf(pd,usr.dnldl-ultoday);
      break;

    case 20:  /* Current Time */
      strftime(string,15,"%H:%M:%S",localtime(((longtime=time(NULL)),&longtime)));
      Puts(string);
      break;

    case 21:  /* AllAnswers Required */
      *allanswers=TRUE;
      break;

    case 22:  /* AllAnswers Optional */
      *allanswers=FALSE;
      break;

    case 23:  /* Total user ULs */
      Printf(pd,usr.upld);
      break;

    case 24:  /* Total user DLs */
      Printf(pd,usr.dnld);
      break;

    case 25:  /* UL:DL ratio */
      Printf("%d:%d",(usr.upld==0 ? 0 : 1),
             (usr.upld==0 ? usr.dnld : usr.dnld/usr.upld));
      break;
  }
}





static int near pascal Parse_Questionnaire(FILE *bbsfile,FILE **questfile,char *onexit,char *filename,int *ck_abort,int *recd_chars,int *skipcr,char **filebufr,char *nonstop,int allanswers)
{
  time_t longtime;

  char string[MAXLEN],
       string2[MAXLEN],
       *p;

  long offset;

  int ch,
      rr;

  switch(ch=fgetc(bbsfile))
  {
    case '^':     /* What follows is TTY only */
    case 'E':     /* What follows is ANSI/AVATAR only */
      if ((ch=='E' && graph==GRAPHICS_none) ||
          (ch=='^' && graph != GRAPHICS_none))
      {
        while (1)
        {
          /* End of ANSI/AVATAR or TTY only */
          if ((ch=fgetc(bbsfile))=='\x0f')
          {
            if ((ch=fgetc(bbsfile))=='e')
              break;
            else ungetc(ch,bbsfile);
          }
          else if (ch==EOF)
            break;
        }
      }
      break;

    case 'M':     /* Append last MENU CHOICE to answer file */
      Get_To_Blank(string,bbsfile);

      if (*questfile)
        fprintf(*questfile,"%s: %c\n",strupr(string),lastmenu);
      break;

    case 'N':     /* Get line and store in answer file! */
      Get_To_Blank(string,bbsfile);

      while (1)
      {
        Input(string2,INPUT_lb_line | INPUT_nohotflash,0,MAXLEN,NULL);

        if (!allanswers)
          break;
        else
        {
          for (p=string2;*p;p++)
            if (isalnum(*p))
              break;

          if (*p) /* If there are alphanumerics, then it's OK, so get out. */
            break;
          else
          {
            Puts(tryagain);
            Clear_KBuffer();
          }
        }
      }
      
      strcpy(last_readln,string2);

      display_line=1;

      if (*questfile)
        fprintf(*questfile,"%s: %s\n",strupr(string),string2);
      break;

    case 'o':
    case 'O':     /* Open answer file */
      Get_To_Blank(string,bbsfile);

      Convert_Star_To_Task(string);
      Add_Full_Path(string,string2);

      if (*questfile)
      {
        fputc('\n',*questfile);
        fclose(*questfile);
      }
      
      *questfile=shfopen(string2,fopen_append,O_WRONLY | O_APPEND);
      break;

    case 'P':     /* Post user info to answer file! */
      if (*questfile)
      {
        fprintf(*questfile,"* %s\t%s\t",usr.name,usr.city);

                        /* Mon Nov 21 11:31:54 1983\n */
        strftime(string,26,"%a %b %d %H:%M:%S %Y\n",localtime(((longtime=time(NULL)),&longtime)));

        /* asctime_format already appends a C/R, no need to add one! */
        fputs(string,*questfile);
      }
      break;

    case 'C':     /* Call DOS with command 'p' (in '^OCp') */
      if (*questfile)
        flush_handle(*questfile);

      Get_BBS_String(string,bbsfile,MAXLEN);

      if (*ck_abort)
        Mdm_flush_ck();
      else Mdm_flush();

      rst_offset=ftell(bbsfile);

      if (*string=='@')
        rr=OUTSIDE_reread,p=string+1;
      else rr=0,p=string;

      Outside(NULL,NULL,OUTSIDE_dos | rr,p,FALSE,CTL_none,RESTART_dotbbs,
              filename);

      Clear_KBuffer();

      rst_offset=-1L;
      break;

    case 'D':     /* Change current directory */
      Get_To_Blank(string,bbsfile);
      Save_Directory2(string);
      break;

    case 'F':     /* On exit filename */
      *recd_chars=FALSE;

      Get_To_Blank(string,bbsfile);
      strcpy(onexit,string);
      strcpy(last_onexit,string);
      break;

    case 'Q':     /* Quit the file immediately */
      return 1;

    case 'R':     /* Read in menu */
      *nonstop=FALSE;
      display_line=1;

      Get_To_Blank(string,bbsfile);

      while (1)
      {
        Input_Char(CINPUT_display | CINPUT_acceptable | CINPUT_lastmenu |
                   (allanswers ? CINPUT_allanswers : 0),string);

        if (allanswers && (lastmenu=='\0' || lastmenu==' ' || lastmenu=='|') && !strchr(string,'|'))
        {
          Puts(tryagain);
          Clear_KBuffer();
        }
        else break;
      }
      break;

    case 'S':     /* Show another file */
      *skipcr=FALSE;

      if (*recd_chars)
      {
        *onexit='\0';
        *last_onexit='\0';
      }

      Get_To_Blank(filename,bbsfile);

      free(*filebufr);
      *filebufr=NULL;

      fclose(bbsfile);
      return 2;

    case 'T':     /* Top of file! */
      *skipcr=FALSE;

      fseek(bbsfile,0L,SEEK_SET);
      break;

    case 'U':     /* User choice - If not the same choice, eat the line */
      ch=fgetc(bbsfile);

      if (lastmenu != toupper((char)ch))
      {
        Skip_Line(bbsfile);
        beginline=TRUE;
      }
      break;

    case 'V':     /* Goto */
      *skipcr=FALSE;

      Get_To_Blank(string,bbsfile);

      sscanf(string,"%5ld",&offset);
      fseek(bbsfile,offset,SEEK_SET);
      break;
  }

  return 0;
}


static int near pascal Parse_MagnusCode(char *filename,FILE *bbsfile,int ck_abort,char **filebufr,FILE *questfile,int type)
{
  time_t longtime;
  struct tm *lt;

  union stamp_combo st;

  char string[PATHLEN],
       temp[PATHLEN],
       *p;

  int ch,
      fd,
      rr;

  int operation,
      hh,h,
      mm,m,
      cond,
      x;

  long tlong;

  switch(fgetc(bbsfile))
  {
    case '\x01':
      Puts(usr.ldate);
      break;

    case '\x02':
      if (local)
        fgetc(bbsfile);
      else switch(fgetc(bbsfile))
      {
        case '1':
          if (baud < 1200L)
            return SKIP_line;
          break;

        case '2':
          if (baud < 2400L)
            return SKIP_line;
          break;

        case '9':
          if (baud < 9600L)
            return SKIP_line;
          break;
      }
      break;

    case '\x05':
      Puts(last_readln);
      break;
      
    case '\x06':
      switch (fgetc(bbsfile))
      {
        case 'A':
          Printf(p2s,Area_Name(usr.files));
          break;

        case 'N':
          if (infilearea)
            Puts(area.fileinfo);
          break;
      }
      break;

    case '\x07':
      Local_Beep(1);
      break;

    case '\x0d':
      switch (fgetc(bbsfile))
      {
        case '#':
          if (inmsgarea)
            Printf(pd,num_msg);
          break;

        case 'A':
          Printf(p2s,Area_Name(usr.msg));
          break;

        case 'L':
          if (inmsgarea)
            Printf(pd,last_msg);
          break;

        case 'H':
          if (inmsgarea)
            Printf(pd,high_msg);
          break;

        case 'N':
          if (inmsgarea)
            Puts(area.msginfo);
          break;

        case 'n':
          switch (fgetc(bbsfile))
          {
            case 'N':
              if (last_msg==high_msg)
                return SKIP_none;
              break;

            case 'R':
              if (last_msg==0)
                return SKIP_none;
              break;

            case 'M':
              if (num_msg==0)
                return SKIP_none;
              break;

            case 'E':
              if (entry==ENTRY_false || entry==ENTRY_noheader)
                return SKIP_none;
              break;
          }
          return SKIP_line;

        case 'i':
          switch (fgetc(bbsfile))
          {
            case 'N':
              if (direction==DIRECTION_next)
                return SKIP_none;
              break;

            case 'P':
              if (direction==DIRECTION_previous)
                return SKIP_none;
              break;

          }
          return SKIP_line;

        case 'a':
          switch (fgetc(bbsfile))
          {
            case 'L':
              if (! (area.attrib[class] & (SYSMAIL | ECHOMAIL)))
                return SKIP_none;
              break;

            case 'E':
              if (area.attrib[class] & ECHOMAIL)
                return SKIP_none;
              break;

            case 'M':
              if (area.attrib[class] & SYSMAIL)
                return SKIP_none;
              break;
          }
          return SKIP_line;

      }
      break;

    case '\x0e':
      switch (fgetc(bbsfile))
      {
        case 'C':
          Printf(pd,usr.credit);
          break;

        case 'D':
          Printf(pd,usr.debit);
          break;

        case 'B':
          Printf(pd,usr.credit-usr.debit);
          break;
      }
      break;

    case '\x10':
      Puts(usr.phone);
      break;

    case '\x12':
      Puts(usr.realname);
      break;

    case '8':     /* Only display if user's screen is >= 79 cols */
      if (usr.width < 79)
        return SKIP_line;
      break;

    case 'A':     /* Add line to system log */
      if (*Get_BBS_String(string,bbsfile,PATHLEN))
      {
        Parse_Outside_Cmd(string,temp);
        logit(temp);
      }
      break;

    case 'c':
      if (ChatFindIndividual(task_num,NULL,NULL,&x))
      {
        switch (fgetc(bbsfile))
        {
          case 'A':
            if (!x)
              return SKIP_line;
            break;

          case 'N':
            if (x)
              return SKIP_line;
        }
      }
      else fgetc(bbsfile); /* Else throw away option */
      break;

    case 'C':
      Msg_Checkmail();
      break;

    case 'D':     /* Unlink (delete) a specific file */
      Get_To_Blank(string,bbsfile);

      Convert_Star_To_Task(string);
      Parse_Outside_Cmd(string,temp);

      if (fexist(temp))
        unlink(temp);
      break;

    case 'e':
      Get_To_Blank(string,bbsfile);
      
       if (! eqstri(string,last_readln))
        return SKIP_line;
      break;
      
    case 'E':     /* Sysop wants out NOW! */
      return -4;

    case 'f':
      Get_To_Blank(string,bbsfile);

      if ((fd=shopen(string,O_RDONLY | O_BINARY))==-1)
        return SKIP_line;

      get_fdt(fd,&st);
      close(fd);

      if (GEdate(&st,&laston))
        return SKIP_none;

      return SKIP_line;

    case 'F':     /* Check for new files */
      strcpy(linebuf,"*");
      File_Locate();
      break;

    case 'G':     /* Abort line if keypress */
      if (Mdm_keyp())
        return SKIP_line;
      break;

    case 'h':     /* If user has hotkeys */
      if (! hotkeys(usr))
        return SKIP_line;
      break;

    case 'H':
      x=(type & DISPLAY_menuhelp) ? menuhelp : usr.help;

      switch (fgetc(bbsfile))
      {
        case 'N':
          if (x != NOVICE)
            return SKIP_line;
          break;

        case 'R':
          if (x != REGULAR)
            return SKIP_line;
          break;

        case 'E':
          if (x != EXPERT)
            return SKIP_line;
          break;

        case 'H':
          if (x != HOTFLASH)
            return SKIP_line;
          break;
      }
      break;

    case 'I':
      switch (fgetc(bbsfile))
      {
        case 'L':
          if (!local)
            return SKIP_line;
          break;

        case 'R':
          if (local)
            return SKIP_line;
          break;
      }
      break;

    case 'K':
      if (menuname)
        strcpy(string,menuname);
      else *string='\0';

      x=Goodbye_Comment();

      *last_name='\0';

      if (*string)
        strcpy(menuname,string);
      else menuname=NULL;
      
      if (x==FALSE)
        return SKIP_line;
      break;

    case 'l':
      switch (fgetc(bbsfile))
      {
        case 'M':
          List_Message_Areas();
          break;

        case 'F':
          List_File_Areas();
          break;
      }
      break;

    case 'L':     /* Link to another file */
      if (questfile)
        flush_handle(questfile);

      Get_To_Blank(string,bbsfile);

      /* If we have a buffer allocated for this file... */
      if (*filebufr)
      {
        /* Here, we turn off the buffering, and free the buffer itself.
           Since we want to get as much mileage as we can out of L)inked
           files, we're freeing the buffer to make room for the next
           one.  If we didn't do this, we'd run out of memory really
           quickly, since each malloc()'d buffer would be stacked on
           top of previous buffers, and they aren't doing any good since
           we're not accessing each file at the same time!                 */

        tlong=ftell(bbsfile);

        setvbuf(bbsfile,NULL,_IONBF,0);
        free(*filebufr);

        /* Display the specified file */

        ch=Display_File(0,NULL,string);

        /* Now, let us re-allocate the buffer, if possible... */
        if ((*filebufr=(char *)malloc(FILEBUFSIZ)) != NULL)
        {
          /* Seek to the right spot so setvbuf doesn't get confused! */

          fseek(bbsfile,tlong,SEEK_SET);
          setvbuf(bbsfile,*filebufr,_IOFBF,FILEBUFSIZ);
          fseek(bbsfile,tlong,SEEK_SET);
        }
        else *filebufr=NULL; /* otherwise where did all our memory go?! */


        /* If SysOp wants out NOW... */
        if (ch==-4)
          return -4;
      }
      else Display_File(0,NULL,string);
      break;

    case 'm':
      if (! inmagnet)
        return SKIP_line;
      break;

    case 'M':     /* Change the menupath to something else */
      Get_To_Blank(string,bbsfile);
      strcpy(menupath,string);

      /* Fix things so we re-read menu, even though menuname may not have  *
       * changed.                                                          */

      *last_name='\0';
      break;

    case 'N':
      switch (fgetc(bbsfile))
      {
        case 'M':
          Header_Message((entry==ENTRY_nocheck || entry==ENTRY_nochecke) ? 
                         ENTRY_nohdre : ENTRY_nohdr);
          break;

        case 'F':
          Header_File(ENTRY_noheader);
          break;

        case 'O':
          Header_None(ENTRY_noheader);
          break;
      }
      break;

    case 'O':
      *linebuf='\0';
      break;

    case 'p':
      switch(fgetc(bbsfile))
      {
        case 'U':
          Priv_Up();
          break;

        case 'D':
          Priv_Down();
          break;
      }
      break;

    case 'P':
      if (strchr(Get_BBS_String(string,bbsfile,MAXLEN),'%'))
        Parse_Outside_Cmd(string,&linebuf[strlen(linebuf)]);
      else strcat(linebuf,string);
      break;

    case 'q':
      if (! (usr.flag & UFLAG_permanent))
        return SKIP_line;
      break;
      
    case 'Q':   /* Display only if the user hasn't been on today */
      if (usr.time)
        return SKIP_line;
      break;

    case 'r':
      x=fgetc(bbsfile);
      Get_BBS_String(temp,bbsfile,PATHLEN);
      BbsRunOpt(x,temp);

/*
      *(p=temp)='\0';
      
      x=fgetc(bbsfile);
      rr=fgetc(bbsfile);
      
      if (rr)
      {
        while (rr--)
          *p++=(char)fgetc(bbsfile);
        
        *p='\0';
        p=temp;
      }
      else p=NULL;

      BbsRunOpt(x,p);
*/
      break;

    case 'R':
      Get_To_Blank(string,bbsfile);

      if (!stristr(usr.city,string))
        return SKIP_line;
      break;

    case 's':   /* Set priv level */
      ch=fgetc(bbsfile);

      for (x=0;x < _PRIVS_NUM;x++)
        if (ch==*_privs[x].name)
        {
          usr.priv=_privs[x].priv;
          Find_Class_Number();
          break;
        }
      break;

    case 'S':
      if (*linebuf)
        return SKIP_line;
      break;

    case 't': /* Parse time code */
      operation=fgetc(bbsfile);
      hh=fgetc(bbsfile)-1;
      mm=fgetc(bbsfile)-1;

      longtime=time(NULL);
      lt=localtime(&longtime);

      h=lt->tm_hour;
      m=lt->tm_min;

      switch (operation)
      {
        case 1: /* GT */
          if ((h==hh && m > mm) || h > hh)
            cond=TRUE;
          else cond=FALSE;
          break;

        case 2: /* LT */
          if ((h==hh && m < mm) || h < hh)
            cond=TRUE;
          else cond=FALSE;
          break;

        case 3: /* EQ */
          if (h==hh && m==mm)
            cond=TRUE;
          else cond=FALSE;
          break;

        case 4: /* NE */
          if (h==hh && m==mm)
            cond=FALSE;
          else cond=TRUE;
          break;

        case 5: /* GE */
          if ((h==hh && m >= mm) || h > hh)
            cond=TRUE;
          else cond=FALSE;
          break;

        case 6: /* LE */
          if ((h==hh && m <= mm) || h < hh)
            cond=TRUE;
          else cond=FALSE;
          break;
      }

      if (cond)
        return SKIP_none;
      else return SKIP_line;

    case 'T':
      ch=fgetc(bbsfile)-'1';

      if (ch >= 0 && ch <= 7)
        if (UserHasKey(ch))
          UserKeyOff(ch);
        else UserKeyOn(ch);
      break;

    case 'w':
      Who_Is_On();
      break;

    case 'W':     /* Write a line (with translations) to the questfile */
      Parse_Outside_Cmd(Get_BBS_String(string,bbsfile,PATHLEN),temp);

      if (questfile)
        fprintf(questfile,"%s\n",temp);
      break;

    case 'X':
      switch (ch=fgetc(bbsfile))
      {
        case 'E':     /* Exit with errorlevel */
        case 'R':     /* Run external program */
        case 'C':     /* Chain (load program over Maximus) */
        case 'D':     /* Run COMMAND.COM, same as ^OC */
          if (questfile)
            flush_handle(questfile);

          Get_BBS_String(string,bbsfile,MAXLEN);

          if (ck_abort)
            Mdm_flush_ck();
          else Mdm_flush();

          rst_offset=ftell(bbsfile);

          switch (ch)
          {
            case 'E':
              ch=OUTSIDE_errorlevel;
              break;

            case 'R':
              ch=OUTSIDE_run;
              break;

            case 'C':
              ch=OUTSIDE_chain;
              break;

            default:
            case 'D':
              ch=OUTSIDE_dos;
              break;
          }

          if (*string=='@')
            rr=OUTSIDE_reread,p=string+1;
          else rr=0,p=string;

          Outside(NULL,NULL,ch | rr,p,FALSE,CTL_none,RESTART_dotbbs,filename);

          brk_trapped=0;
          rst_offset=-1L;
          break;
      }
      break;
  }

  return 0;
}


int pascal Parse_Priv(FILE *bbsfile)  /* 1==EOF 2==EOL */
{
  int ch;

  switch (ch=fgetc(bbsfile))
  {
    case 'L':     /* Show rest of line to <ch> and above */
    case 'B':
    case 'Q':
    case 'X':
      return (Priv_Code(fgetc(bbsfile),ch));

    case 'F':
      ch=fgetc(bbsfile);
      /* fall-through */

    default:
      if (Priv_Code(ch,'L')==SKIP_line)
        return SKIP_file;
      else return SKIP_none;
  }
}




int pascal Priv_Code(int ch,int action)
{
  int priv=HIDDEN,
      x;

  if (ch >= '1' && ch <= '8')
  {
    if (action=='Q')
    {
      if (! UserHasKey(ch-'1'))
        return SKIP_line;
      else return SKIP_none;
    }
    else if (action=='X')
    {
      if (UserHasKey(ch-'1'))
        return SKIP_line;
      else return SKIP_none;
    }
    else return SKIP_line;
  }

  for (x=0,priv=TWIT;x < _PRIVS_NUM;x++)
    if (ch==*_privs[x].name)
    {
      priv=_privs[x].priv;
      break;
    }

  switch (action)
  {
    case 'Q':                   /* Equal to priv <x> */
      if (usr.priv==priv)
        return SKIP_none;
      else return SKIP_line;

    case 'X':                   /* NOT equal to priv <x> */
      if (usr.priv != priv)
        return SKIP_none;
      else return SKIP_line;

    case 'B':                   /* Below priv <x> */
      if (LEPriv(usr.priv,priv))
        return SKIP_none;
      else return SKIP_line;

    case 'L':                   /* Greater/equal to priv <x> */
      if (GEPriv(usr.priv,priv))
        return SKIP_none;
      else return SKIP_line;

  }

  return SKIP_none;
}



char * pascal Ordinal(int number)
{
  number %= 100;

  if (number > 10 && number < 20)
    return ordinal_th;

  switch(number % 10)
  {
    case 1:
      return ordinal_st;

    case 2:
      return ordinal_nd;

    case 3:
      return ordinal_rd;

    default:
      return ordinal_th;
  }
}



/* Keep getting from a file until the next blank/extended ASCII */

void pascal Get_To_Blank(char *s,FILE *f)
{
  int c;
  int s1,
      s2;

  while (((c=fgetc(f)) > 32 && c < 127) || c==25)
  {
    if (c==25)  /* Expand any RLE sequences */
    {
      s1=fgetc(f);
      s2=fgetc(f);

      while (s2--)  /* Expand the character 's1', a total of 's2' times */
        *s++=(char)s1;
    }
    else *s++=(char)c;
  }

  /* Get rid of the LF after the CR */
  if (c==13)
    fgetc(f);

  *s='\0';
}



static void near pascal Fix_RLE(char *s)
{
  char temp[PATHLEN],
       *p=temp,
       *orig=s;

  int s1,
      s2;

  if (strlen(s) >= PATHLEN)
    s[PATHLEN-1]='\0';

  while (*s)
  {
    if (*s==25)  /* Expand any RLE sequences */
    {
      s1=*++s;
      s2=*++s;

      while (s2--)  /* Expand the character 's1', a total of 's2' times */
        *p++=(char)s1;

      s++;
    }
    else *p++=*s++;
  }

  *p='\0';

  strcpy(orig,temp);
}

      
static char * pascal Get_BBS_String(char *string,FILE *bbsfile,int max)
{
  fgets(string,max,bbsfile);
  Fix_RLE(string);
  Trim_Line(string);
  
  return string;
}




static void pascal Add_Full_Path(char *src,char *dest)
{
  char temp[PATHLEN];

  if (src[1]==':' || *src=='\\' || *src=='/' || *src=='.')
    strcpy(dest,src);
  else sprintf(dest,ss,original_path,src);

  if (dest[1] != ':')
  {
    temp[0]=*original_path;
    temp[1]=':';
    temp[2]='\0';
    strcat(temp,dest);
    strcpy(dest,temp);
  }
}


int pascal Process_Files_Entry(int *type,char *orig_entry,char *nonstop,int ck_abort)
{
  union stamp_combo stamp;

  FFIND *ff=NULL;

  char filename[255],
       temp[255],
       string[PATHLEN],
       *p,*s,*s2;

  int slsf, /* slsf==strlen(searchfor). */
      doit, /* If we can display entry, based on newness, keywords, etc. */
      begl, /* Temporary holding place for NEW beginline value! */
      isoffline, /* If the current file IS off-line */
      y;    /* Scratch loop variable */

  begl=beginline;

  if (Trim_Line(orig_entry))
    begl=TRUE;

  strcpy(temp,orig_entry);

  getword(temp,filename," \t\n",1);

  if (strchr(filename,'\x19'))
    Fix_RLE(filename);

  if ((prm.flags & FLAG_autodate) || (*type & DISPLAY_newfiles))
    isoffline=((ff=FindOpen(strupr(filename),0))==NULL);
  else isoffline=FALSE;

  while (1)
  {
    if (isoffline)
      stamp.ldate=0L;
    else
    {
      if ((prm.flags & FLAG_autodate) || (*type & DISPLAY_newfiles))
      {
        strcpy(filename,ff->ff_name);
        strcpy(temp,orig_entry); /* So any AVATAR codes won't be duplicated on 2nd pass */
        stamp.dos_st.date=ff->ff_fdate;
        stamp.dos_st.time=ff->ff_ftime;
      }
    }

    for (y=strlen(filename);y < 12;y++)
      filename[y]=' ';

    filename[12]='\0';
    strupr(filename);

    if (*type & DISPLAY_newfiles)
    {
      if (!beginline || isoffline)
        doit=FALSE;
      else if ((doit=GEdate(&stamp,&new_date)) != FALSE)
        matches++;
    }
    else if (*type & DISPLAY_search)
    {
      if (!beginline)
        doit=FALSE;
      else
      {
        /* If we can find it in either the filename or description... */
        if ((p=stristr(filename,searchfor)) != NULL ||
            (p=stristr(temp,searchfor)) != NULL)
        {
          slsf=strlen(searchfor);
          strlwr(filename);
          strlwr(temp);

          /* Move everything AFTER the string we found, to the right
             three places, so we can insert the cyan colour code here */

          memmove(p+slsf+3,p+slsf,strlen(p+slsf)+1);

          p[slsf  ]='\x16';
          p[slsf+1]='\x01';
          p[slsf+2]='\x03';

          for (y=0;y < slsf;y++)
            p[y]=toupper(p[y]);

          /* Now move everything after the FRONT of the string we found,
             to the right three places, so we can insert the light-yellow
             colour code.                                              */

          memmove(p+3,p,strlen(p)+1);
          p[0]='\x16';
          p[1]='\x01';
          p[2]='\x0e';

          memmove(filename+3,filename,strlen(filename)+1);

          filename[0]='\x16';
          filename[1]='\x01';
          filename[2]='\x03';

          matches++;  /* Found a match on search pattern */
          doit=TRUE;
        }
        else doit=FALSE;
      }
    }
    else doit=TRUE;

    if (doit)
    {
      if (*type & DISPLAY_areaname)
      {
        Puts(space_over);
        Printf(file_name,Area_Name(usr.files),area.fileinfo);

        /* Only display area's name once */
        *type &= ~DISPLAY_areaname;
      }

      if (MoreYnBreak(nonstop,NULL))
      {
        beginline=(char)begl;

        if ((prm.flags & FLAG_autodate) || (*type & DISPLAY_newfiles))
          FindClose(ff);

        return -2;
      }

      Printf(YELLOW "%s ",filename);

      if (prm.flags & FLAG_autodate)
      {
        if (isoffline)
          Printf(s(file_offline),prm.date_style==3 ?
                 '\x07' : '\x09');
        else
        {
          Printf(MAGENTA "%7ld " GREEN,ff->ff_fsize);

          switch (prm.date_style)
          {
            case 0:
              Printf(s(date_str),stamp.msg_st.date.mo,
                                 stamp.msg_st.date.da,
                                 stamp.msg_st.date.yr+80);
              break;

            case 1:
              Printf(s(date_str),stamp.msg_st.date.da,
                                 stamp.msg_st.date.mo,
                                 stamp.msg_st.date.yr+80);
              break;

            case 2:
              Printf(s(date_str),stamp.msg_st.date.yr+80,
                                 stamp.msg_st.date.mo,
                                 stamp.msg_st.date.da);
              break;

            case 3:
              Printf(s(datestr),stamp.msg_st.date.yr+80,
                                stamp.msg_st.date.mo,
                                stamp.msg_st.date.da);
              break;
          }
        }
      }

      if (ck_abort && (brk_trapped || mdm_halt()))
      {
        brk_trapped=0;
        mdm_dump(DUMP_all);

        if ((prm.flags & FLAG_autodate) || (*type & DISPLAY_newfiles))
          FindClose(ff);

        return -2;
      }

      if (prm.flags & FLAG_autodate)
      {
        if (!isoffline && GEdate(&stamp,(*type & DISPLAY_newfiles) ?
                                 &new_date : &laston))
          Puts(BLINK "* ");
        else Puts("  ");
      }

      p=firstchar(temp," \t\n",2);

      if (p > temp+14 && isspace(*(temp+14)))
        p=temp+14;
      
      if (!p)
        p=blank_str;
      
      Puts(CYAN);
      
      s=p;
      
      while (*s)
      {
        s2=string;

        while (*s && *s != ' ' && *s != '-')
          *s2++=*s++;
      
        /* Copy the delimiter to the end of the string, and cap it. */

        if (*s)
          *s2++=*s++;
        
        *s2='\0';
        s2=string;

        /* If word would cause a wordwrap */
        
        if (current_col+stravtlen(string) > usr.width)
        {
          /* Jump to next line, and indent */
          Printf("\n\x19 %c",(prm.date_style==3 ? '\x1d' :
                 (prm.date_style==-1 ? '\x0e' : '\x1f'))-
                 ((prm.flags & FLAG_autodate) ? 0 : 1));
               
          /* Strip off any beginning whitespace */
          while (*s2==' ')
            s2++;
        }

        Puts(s2);
      }

      Putc('\n');
    }

    /* Don't display any more matches if the file is off-line, doesn't     *
     * contain any wildcards, or if no more matches exist.                 */

    if (isoffline || strpbrk(orig_entry,"?*")==NULL ||
        (!(prm.flags & FLAG_autodate) && !(*type & DISPLAY_newfiles)) ||
        FindNext(ff) != 0)
      break;
  }

  beginline=(char)begl;

  if ((prm.flags & FLAG_autodate) || (*type & DISPLAY_newfiles))
    FindClose(ff);

  return 0;
}


int stravtlen(char *s) /* To calculate len of string with \x16\x01\xXX seqs */
{
  int count=0;
  
  while (*s)
    if (*s++=='\x16')
      s += 2;
    else count++;

  return count;
}

/*  Parse_Outside_Cmd() -- An translator for outside commands.  This       *
 *                         function takes a printf()-style string, and     *
 *                         converts the values contained within to         *
 *                         various system parameters, which may be useful  *
 *                         to the program we're calling.  The currently-   *
 *                         supported translations are:                     *
 *                                                                         *
 *  %A -- The user's first name, all in caps                               *
 *  %b -- Baud rate.  If the user is LOCAL, then 0 will be used.           *
 *  %B -- The user's last name, all in caps                                *
 *  %c -- User's city                                                      *
 *  %C -- The response to the user's last ^oR ("[menu]") command.          *
|*  %d -- The area number of the current message area                      *
|*  %D -- The area number of the current file area                         *
|*  %e -- The user's password                                              *
|*  %E -- The user's screen length, in rows                                *
 *  %f -- User's first name, in mixed case                                 *
 *  %F -- Path to the current file area, with trailing backslash           *
 *  %g -- Whether or not the user has graphics support:                    *
 *          A '0' will be used if the user is TTY,                         *
 *          a '1' will be used if the user has ANSI,                       *
 *          and a '2' will be used if the user has AVATAR.                 *
|*  %G -- Daily DL limit, in kilobytes                                     *
 *  %h -- The user's phone number                                          *
|*  %H -- Number of kilobytes downloaded today                             *
|*  %i -- Total downloads                                                  *
|*  %I -- Total uploads                                                    *
|*  %j -- Minutes on-line, this call                                       *
|*  %J -- Last string user entered for [readln]                            *
 *  %k -- The current node's task number (0 for no task number)            *
 *  %l -- User's last name, in mixed case                                  *
 *  %L -- If the user is LOCAL, then this becomes the string "-k".         *
 *        Otherwise, it becomes the string "-px -by", where 'x' is the     *
 *        port number (1==COM1:, 2==COM2:, etc.), and 'y' is the baud      *
 *        rate.                                                            *
 *  %M -- Path to the current message area, with trailing backlash         *
 *  %n -- User's full name, in mixed case                                  *
 *  %N -- The name of your BBS, as defined in your .CTL file.              *
 *  %p -- Port number (0=COM1, 1=COM2, etc.)                               *
 *  %P -- Port number (1=COM1, 2=COM2, etc.)                               *
|*  %q -- Path to the current msg area (NO trailing backslash)             *
|*  %Q -- Path to the current file area (NO trailing backslash)            *
 *  %r -- The user's real name, if applicable                              *
 *  %s -- The Sysop's last name                                            *
 *  %S -- The Sysop's first name                                           *
 *  %t -- User's time left in minutes, rounded to nearest minute           *
 *  %T -- User's time left, in seconds                                     *
 *  %u -- User's user number                                               *
 *  %U -- Translates to an underscore ("_").                               *
|*  %v -- Path to the current upload area (with trailing backslash)        *
|*  %V -- Path to the current upload area (NO trailing backslash)          *
 *  %Z -- Translates to user's full name, in caps                          *
 *  %% -- Translates to a percent sign                                     */

int pascal Parse_Outside_Cmd(char *parm,char *outparm)
{
  char temp[PATHLEN],
       *in,
       *out,
       *p;

  for (in=parm,out=outparm;*in;in++)
  {
    if (*in=='%')
    {
      switch (*++in)
      {
        case 'b':
          if (local)
              strcpy(out,zero);
          else sprintf(out,"%ld",baud);
          break;

        case 'c':
          strcpy(out,usr.city);
          break;

        case 'd':
          strcpy(out,Area_Name(usr.msg));
          break;

        case 'e':
          strcpy(out,usr.pwd);
          break;

        case 'f':
          strcpy(out,firstname);
          break;

        case 'g':
          switch (graph)
          {
            case GRAPHICS_none:
              strcpy(out,zero);
              break;

            case GRAPHICS_ansi:
              strcpy(out,one);
              break;

            case GRAPHICS_avatar:
              strcpy(out,"2");
              break;
          }
          break;

        case 'h':
          strcpy(out,usr.phone);
          break;

        case 'i':
          sprintf(out,pd,usr.dnld);
          break;

        case 'j':
          sprintf(out,pd,timeonline());
          break;

        case 'k':
          sprintf(out,pd,task_num);
          break;

        case 'l':
          strcpy(out,(p=firstchar(usr.name,ctl_delim,2))==NULL ? s(no_last) : p);
          break;

        case 'n':
          strcpy(out,usr.name);
          break;

        case 'p':
        case 'P':
          if (local)
            sprintf(out,pd,*in=='P' ? 0 : -1);
          else
          {
            #ifdef OS_2
              sprintf(out,pd,   ComGetFH(hcModem));
            #else
              sprintf(out,pd,  port+(*in=='P' ? 1 : 0));
            #endif
          }
          break;

        case 'q':
          strcpy(out,area.msgpath);

          if (strlen(out) > 3)
            out[strlen(out)-1]='\0';
          break;

        case 'r':
          strcpy(out,usr.realname);
          break;

        case 's':
          strcpy(out,(p=firstchar(PRM(sysop),ctl_delim,2))==NULL ? s(no_last) : p);
          break;

        case 't':
          sprintf(out,pd,timeleft());
          break;

        case 'u':
          sprintf(out,pd,usernum);
          break;

        case 'v':
          strcpy(out,area.uppath);
          break;

        case 'A':
          strcpy(out,firstname);
          strupr(out);
          break;

        case 'B':
          strcpy(out,(p=firstchar(usr.name,ctl_delim,2))==NULL ? s(no_last) : p);
          strupr(out);
          break;

        case 'C':
          sprintf(out,"%c",lastmenu);
          break;

        case 'D':
          strcpy(out,Area_Name(usr.files));
          break;

        case 'E':
          sprintf(out,pd,usr.len);
          break;

        case 'F':
          strcpy(out,area.filepath);
          break;

        case 'G':
          sprintf(out,pd,prm.class[class].max_dl);
          break;

        case 'H':
          sprintf(out,pd,usr.dnldl);
          break;

        case 'I':
          sprintf(out,pd,usr.upld);
          break;
          
        case 'J':
          strcpy(out,last_readln);
          break;

        case 'L':
          if (local)
            strcpy(out,"-k");
          else sprintf(out,"-p%d -b%ld",port,baud);
          break;

        case 'M':
          strcpy(out,area.msgpath);
          break;

        case 'N':
          strcpy(out,PRM(system_name));
          break;

        case 'Q':
          strcpy(out,area.filepath);

          if (strlen(out) > 3)
            out[strlen(out)-1]='\0';
          break;

        case 'S':
          getword(PRM(sysop),temp,ctl_delim,1);
          strcpy(out,temp);
          break;

        case 'T':
          sprintf(out,"%ld",timeoff-time(NULL));
          break;

        case 'U':
          strcpy(out,"_");
          break;

        case 'V':
          strcpy(out,area.uppath);

          if (strlen(out) > 3)
            out[strlen(out)-1]='\0';
          break;

        case 'Z':
          strcpy(out,usr.name);
          strupr(out);
          break;

        case '%':
          strcpy(out,"%");
          break;

        default:        /* Invalid command */
          *out='\0';
          break;
      }

      out += strlen(out);
    }
    else *out++=*in;
  }

  *out='\0';

  return (strlen(outparm));
}


static void near pascal PF(FILE *bbsfile,int n)
{
  while (n--)
    Putc(fgetc(bbsfile));
}

